/*
 * Tesselation_InsideOutsideUnitTest.hpp
 *
 *  Created on: Dec 28, 2009
 *      Author: heber
 */

#ifndef TESSELATION_INSIDEOUTSIDEUNITTEST_HPP_
#define TESSELATION_INSIDEOUTSIDEUNITTEST_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

/*********************************************** includes ***********************************/

#include <cppunit/extensions/HelperMacros.h>

#include <vector>

#include "LinearAlgebra/Vector.hpp"
#include "LinearAlgebra/VectorSet.hpp"
#include "LinkedCell/linkedcell.hpp"

class Tesselation;

/********************************************** Test classes **************************************/

class TesselationInOutsideTest : public CppUnit::TestFixture
{
    CPPUNIT_TEST_SUITE( TesselationInOutsideTest) ;
    CPPUNIT_TEST ( IsInnerPointCubeTest );
    CPPUNIT_TEST ( IsInnerPointSphereTest );
    CPPUNIT_TEST ( IsInnerPointNonConvexTest );
    CPPUNIT_TEST_SUITE_END();

public:
      void setUp();
      void tearDown();
      void IsInnerPointCubeTest();
      void IsInnerPointSphereTest();
      void IsInnerPointNonConvexTest();

private:
      void prepareCorners(const std::vector<Vector> &Vectors);
      std::vector<Vector> translateAndexpand(
          VECTORSET(std::vector) Vectors, const double factor, const Vector &offset) const;
      std::vector<Vector> setupCube() const;
      std::vector<Vector> setupSphere() const;
      std::vector<Vector> setupNonConvex() const;
      void prepareTesselation(const double SPHERERADIUS);
      void removeTesselation();

      class Tesselation *TesselStruct;
      TesselPointSTLList Corners;
      class LinkedCell_deprecated *LinkedList;
};


#endif /* TESSELATION_INSIDEOUTSIDEUNITTEST_HPP_ */
